edelib: TiXmlNode Class Reference

edelib 1.0

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Member Functions | Friends | List of all members
TiXmlNode Class Referenceabstract

Parent class for everything in DOM. More...

`#include <edelib/TiXml.h>`

Inheritance diagram for TiXmlNode:

## Public Types
enum | NodeType { DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, DECLARATION, TYPECOUNT }
Public Types inherited from TiXmlBase
enum | { TIXML_NO_ERROR = 0, TIXML_ERROR, TIXML_ERROR_OPENING_FILE, TIXML_ERROR_OUT_OF_MEMORY, TIXML_ERROR_PARSING_ELEMENT, TIXML_ERROR_FAILED_TO_READ_ELEMENT_NAME, TIXML_ERROR_READING_ELEMENT_VALUE, TIXML_ERROR_READING_ATTRIBUTES, TIXML_ERROR_PARSING_EMPTY, TIXML_ERROR_READING_END_TAG, TIXML_ERROR_PARSING_UNKNOWN, TIXML_ERROR_PARSING_COMMENT, TIXML_ERROR_PARSING_DECLARATION, TIXML_ERROR_DOCUMENT_EMPTY, TIXML_ERROR_EMBEDDED_NULL, TIXML_ERROR_PARSING_CDATA, TIXML_ERROR_DOCUMENT_TOP_ONLY, TIXML_ERROR_STRING_COUNT }

## Public Member Functions
const char * | Value () const
void | SetValue (const char *_value)
void | Clear ()
TiXmlNode * | Parent ()
const TiXmlNode * | Parent () const
const TiXmlNode * | FirstChild () const
TiXmlNode * | FirstChild ()
const TiXmlNode * | FirstChild (const char *value) const
TiXmlNode * | FirstChild (const char *_value)
const TiXmlNode * | LastChild () const
TiXmlNode * | LastChild ()
const TiXmlNode * | LastChild (const char *value) const
TiXmlNode * | LastChild (const char *_value)
const TiXmlNode * | IterateChildren (const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const TiXmlNode *previous)
const TiXmlNode * | IterateChildren (const char *value, const TiXmlNode *previous) const
TiXmlNode * | IterateChildren (const char *_value, const TiXmlNode *previous)
TiXmlNode * | InsertEndChild (const TiXmlNode &addThis)
TiXmlNode * | LinkEndChild (TiXmlNode *addThis)
TiXmlNode * | InsertBeforeChild (TiXmlNode *beforeThis, const TiXmlNode &addThis)
TiXmlNode * | InsertAfterChild (TiXmlNode *afterThis, const TiXmlNode &addThis)
TiXmlNode * | ReplaceChild (TiXmlNode *replaceThis, const TiXmlNode &withThis)
bool | RemoveChild (TiXmlNode *removeThis)
const TiXmlNode * | PreviousSibling () const
TiXmlNode * | PreviousSibling ()
const TiXmlNode * | PreviousSibling (const char *) const
TiXmlNode * | PreviousSibling (const char *_prev)
const TiXmlNode * | NextSibling () const
TiXmlNode * | NextSibling ()
const TiXmlNode * | NextSibling (const char *) const
TiXmlNode * | NextSibling (const char *_next)
const TiXmlElement * | NextSiblingElement () const
TiXmlElement * | NextSiblingElement ()
const TiXmlElement * | NextSiblingElement (const char *) const
TiXmlElement * | NextSiblingElement (const char *_next)
const TiXmlElement * | FirstChildElement () const
TiXmlElement * | FirstChildElement ()
const TiXmlElement * | FirstChildElement (const char *_value) const
TiXmlElement * | FirstChildElement (const char *_value)
int | Type () const
const TiXmlDocument * | GetDocument () const
TiXmlDocument * | GetDocument ()
bool | NoChildren () const
virtual const TiXmlDocument * | ToDocument () const
virtual const TiXmlElement * | ToElement () const
virtual const TiXmlComment * | ToComment () const
virtual const TiXmlUnknown * | ToUnknown () const
virtual const TiXmlText * | ToText () const
virtual const TiXmlDeclaration * | ToDeclaration () const
virtual TiXmlDocument * | ToDocument ()
virtual TiXmlElement * | ToElement ()
virtual TiXmlComment * | ToComment ()
virtual TiXmlUnknown * | ToUnknown ()
virtual TiXmlText * | ToText ()
virtual TiXmlDeclaration * | ToDeclaration ()
virtual TiXmlNode * | Clone () const =0
virtual bool | Accept (TiXmlVisitor *visitor) const =0
Public Member Functions inherited from TiXmlBase
virtual void | Print (FILE *cfile, int depth) const =0
int | Row () const
int | Column () const
void | SetUserData (void *user)
void * | GetUserData ()
const void * | GetUserData () const

## Protected Member Functions
| TiXmlNode (NodeType _type)
void | CopyTo (TiXmlNode *target) const
TiXmlNode * | Identify (const char *start, TiXmlEncoding encoding)

## Friends
class | TiXmlDocument
class | TiXmlElement

## Additional Inherited Members
Static Public Member Functions inherited from TiXmlBase
static void | SetCondenseWhiteSpace (bool condense)
static bool | IsWhiteSpaceCondensed ()
Static Protected Member Functions inherited from TiXmlBase
static const char * | ReadName (const char *p, edelib::String *name, TiXmlEncoding encoding)
static const char * | ReadText (const char *in, edelib::String *text, bool ignoreWhiteSpace, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static const char * | GetEntity (const char *in, char *value, int *length, TiXmlEncoding encoding)
static const char * | GetChar (const char *p, char *_value, int *length, TiXmlEncoding encoding)
static void | PutString (const edelib::String &str, edelib::String *out)
static bool | StringEqual (const char *p, const char *endTag, bool ignoreCase, TiXmlEncoding encoding)
static int | IsAlpha (unsigned char anyByte, TiXmlEncoding encoding)
static int | IsAlphaNum (unsigned char anyByte, TiXmlEncoding encoding)
static int | ToLower (int v, TiXmlEncoding encoding)
static void | ConvertUTF32ToUTF8 (unsigned long input, char *output, int *length)
Protected Attributes inherited from TiXmlBase
TiXmlCursor | location
void * | userData
Static Protected Attributes inherited from TiXmlBase
static const char * | errorString [TIXML_ERROR_STRING_COUNT]

## Detailed Description

Parent class for everything in DOM.

The parent class for everything in the Document Object Model. (Except for attributes). Nodes have siblings, a parent, and children. A node can be in a document, or stand on its own. The type of a TiXmlNode can be queried, and it can be cast to its more defined type.

## Member Enumeration Documentation

enum NodeType

The types of XML nodes supported by TinyXml. (All the unsupported types are picked up by UNKNOWN.)

## Constructor & Destructor Documentation

TiXmlNode | ( | NodeType | _type | ) |
| protected

Constructor

Referenced by TiXmlText::TiXmlText(), and ToDeclaration().

## Member Function Documentation

virtual bool Accept | ( | TiXmlVisitor * | visitor | ) | const
| pure virtual

Accept a hierchical visit the nodes in the TinyXML DOM. Every node in the XML tree will be conditionally visited and the host will be called back via the TiXmlVisitor interface.

This is essentially a SAX interface for TinyXML. (Note however it doesn't re-parse the XML for the callbacks, so the performance of TinyXML is unchanged by using this interface versus any other.)

The interface has been based on ideas from:

- http://www.saxproject.org/
- http://c2.com/cgi/wiki?HierarchicalVisitorPattern

Which are both good references for "visiting".

An example of using Accept():

    *   TiXmlPrinter printer;
    *   tinyxmlDoc.Accept( &printer );
    *   const char* xmlcstr = printer.CStr();
    *

Implemented in TiXmlDocument, TiXmlUnknown, TiXmlDeclaration, TiXmlText, TiXmlComment, and TiXmlElement.

void Clear | ( |  | ) |

Delete all the children of this node. Does not affect 'this'

Referenced by SetValue().

virtual TiXmlNode* Clone | ( |  | ) | const
| pure virtual

Create an exact duplicate of this node and return it. The memory must be deleted by the caller.

Implemented in TiXmlUnknown, TiXmlDeclaration, TiXmlComment, and TiXmlElement.

void CopyTo | ( | TiXmlNode * | target | ) | const
| protected

Copy to the allocated object. Shared functionality between Clone, Copy constructor, and the assignment operator.

Referenced by TiXmlText::operator=(), TiXmlUnknown::operator=(), TiXmlText::TiXmlText(), TiXmlUnknown::TiXmlUnknown(), ToDeclaration(), and TiXmlText::ToText().

const TiXmlNode* FirstChild | ( |  | ) | const
| inline

The first child of this node. Will be null if there are no children.

Referenced by FirstChild(), and LastChild().

TiXmlNode* FirstChild | ( |  | ) |
| inline

The first child of this node. Will be null if there are no children.

References FirstChild().

const TiXmlNode* FirstChild | ( | const char * | value | ) | const

The first child of this node with the matching 'value'. Will be null if none found.

TiXmlNode* FirstChild | ( | const char * | _value | ) |
| inline

The first child of this node with the matching 'value'. Will be null if none found.

const TiXmlElement* FirstChildElement | ( |  | ) | const

Convenience function to get through elements.

Referenced by FirstChildElement(), and NextSiblingElement().

TiXmlElement* FirstChildElement | ( |  | ) |
| inline

Convenience function to get through elements.

References FirstChildElement().

const TiXmlElement* FirstChildElement | ( | const char * | _value | ) | const

Convenience function to get through elements.

TiXmlElement* FirstChildElement | ( | const char * | _value | ) |
| inline

Convenience function to get through elements.

References FirstChildElement().

const TiXmlDocument* GetDocument | ( |  | ) | const

Return a pointer to the Document this node lives in. Returns null if not in a document.

Referenced by Type().

TiXmlDocument* GetDocument | ( |  | ) |
| inline

Non-const version of GetDocument()

TiXmlNode* Identify | ( | const char * | start,
|  | TiXmlEncoding | encoding
| ) |  |
| protected

Figure out what is at *p, and parse it. Returns null if it is not an xml node.

Referenced by ToDeclaration().

TiXmlNode* InsertAfterChild | ( | TiXmlNode * | afterThis,
|  | const TiXmlNode & | addThis
| ) |  |

Add a new node related to this. Adds a child after the specified child. Returns a pointer to the new object or NULL if an error occured.

Referenced by IterateChildren().

TiXmlNode* InsertBeforeChild | ( | TiXmlNode * | beforeThis,
|  | const TiXmlNode & | addThis
| ) |  |

Add a new node related to this. Adds a child before the specified child. Returns a pointer to the new object or NULL if an error occured.

Referenced by IterateChildren().

TiXmlNode* InsertEndChild | ( | const TiXmlNode & | addThis | ) |

Add a new node related to this. Adds a child past the LastChild. Returns a pointer to the new object or NULL if an error occured.

Referenced by IterateChildren().

const TiXmlNode* IterateChildren | ( | const TiXmlNode * | previous | ) | const

An alternate way to walk the children of a node. One way to iterate over nodes is:

    *   for( child = parent->FirstChild(); child; child = child->NextSibling() )
    *

IterateChildren does the same thing with the syntax:

    *   child = 0;
    *   while( child = parent->IterateChildren( child ) )
    *

IterateChildren takes the previous child as input and finds the next one. If the previous child is null, it returns the first. IterateChildren will return null when done.

Referenced by IterateChildren(), and LastChild().

TiXmlNode* IterateChildren | ( | const TiXmlNode * | previous | ) |
| inline

Non-const form of IterateChildren()

References IterateChildren().

const TiXmlNode* IterateChildren | ( | const char * | value,
|  | const TiXmlNode * | previous
| ) |  | const

This flavor of IterateChildren searches for children with a particular 'value'

TiXmlNode* IterateChildren | ( | const char * | _value,
|  | const TiXmlNode * | previous
| ) |  |
| inline

This flavor of IterateChildren searches for children with a particular 'value'

References InsertAfterChild(), InsertBeforeChild(), InsertEndChild(), IterateChildren(), LinkEndChild(), RemoveChild(), and ReplaceChild().

const TiXmlNode* LastChild | ( |  | ) | const
| inline

The last child of this node. Will be null if there are no children.

Referenced by LastChild().

TiXmlNode* LastChild | ( |  | ) |
| inline

The last child of this node. Will be null if there are no children.

References LastChild().

const TiXmlNode* LastChild | ( | const char * | value | ) | const

The last child of this node matching 'value'. Will be null if there are no children.

TiXmlNode* LastChild | ( | const char * | _value | ) |
| inline

The last child of this node matching 'value'. Will be null if there are no children.

References FirstChild(), IterateChildren(), and LastChild().

TiXmlNode* LinkEndChild | ( | TiXmlNode * | addThis | ) |

Add a new node related to this. Adds a child past the LastChild.

NOTE: the node to be added is passed by pointer, and will be henceforth owned (and deleted) by tinyXml. This method is efficient and avoids an extra copy, but should be used with care as it uses a different memory model than the other insert functions.

See also
  InsertEndChild

Referenced by IterateChildren().

const TiXmlNode* NextSibling | ( |  | ) | const
| inline

Navigate to a sibling node.

Referenced by NextSibling(), and PreviousSibling().

TiXmlNode* NextSibling | ( |  | ) |
| inline

Navigate to a sibling node.

References NextSibling().

const TiXmlNode* NextSibling | ( | const char * |  | ) | const

Navigate to a sibling node with the given 'value'.

TiXmlNode* NextSibling | ( | const char * | _next | ) |
| inline

Navigate to a sibling node with the given 'value'.

References NextSiblingElement().

const TiXmlElement* NextSiblingElement | ( |  | ) | const

Convenience function to get through elements.

Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

Referenced by NextSibling(), and NextSiblingElement().

TiXmlElement* NextSiblingElement | ( |  | ) |
| inline

Non-const version of NextSiblingElement()

References NextSiblingElement().

const TiXmlElement* NextSiblingElement | ( | const char * |  | ) | const

Convenience function to get through elements.

Calls NextSibling and ToElement. Will skip all non-Element nodes. Returns 0 if there is not another element.

TiXmlElement* NextSiblingElement | ( | const char * | _next | ) |
| inline

Non-const version of NextSiblingElement()

References FirstChildElement(), and NextSiblingElement().

bool NoChildren | ( |  | ) | const
| inline

Returns true if this node has no children

TiXmlNode* Parent | ( |  | ) |
| inline

One step up the DOM

const TiXmlNode* Parent | ( |  | ) | const
| inline

One step up the DOM

const TiXmlNode* PreviousSibling | ( |  | ) | const
| inline

Navigate to a sibling node

Referenced by PreviousSibling().

TiXmlNode* PreviousSibling | ( |  | ) |
| inline

Navigate to a sibling node

References PreviousSibling().

const TiXmlNode* PreviousSibling | ( | const char * |  | ) | const

Navigate to a sibling node

TiXmlNode* PreviousSibling | ( | const char * | _prev | ) |
| inline

Navigate to a sibling node

References NextSibling(), and PreviousSibling().

bool RemoveChild | ( | TiXmlNode * | removeThis | ) |

Delete a child of this node

Referenced by IterateChildren().

TiXmlNode* ReplaceChild | ( | TiXmlNode * | replaceThis,
|  | const TiXmlNode & | withThis
| ) |  |

Replace a child of this node. Returns a pointer to the new object or NULL if an error occured.

Referenced by IterateChildren().

void SetValue | ( | const char * | _value | ) |
| inline

Changes the value of the node. Defined as:

    *   Document: filename of the xml file
    *   Element: name of the element
    *   Comment: the comment text
    *   Unknown: the tag contents
    *   Text: the text string
    *

References Clear().

Referenced by TiXmlText::TiXmlText().

virtual const TiXmlComment* ToComment | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlComment.

virtual TiXmlComment* ToComment | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlComment.

virtual const TiXmlDeclaration* ToDeclaration | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlDeclaration.

virtual TiXmlDeclaration* ToDeclaration | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlDeclaration.

References TiXmlElement::Accept(), TiXmlElement::Clone(), CopyTo(), Identify(), TiXmlElement::operator=(), and TiXmlNode().

virtual const TiXmlDocument* ToDocument | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlDocument.

virtual TiXmlDocument* ToDocument | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlDocument.

virtual const TiXmlElement* ToElement | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlElement.

virtual TiXmlElement* ToElement | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlElement.

virtual const TiXmlText* ToText | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlText.

virtual TiXmlText* ToText | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlText.

virtual const TiXmlUnknown* ToUnknown | ( |  | ) | const
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlUnknown.

virtual TiXmlUnknown* ToUnknown | ( |  | ) |
| inlinevirtual

Cast to a more defined type. Will return null if not of the requested type

Reimplemented in TiXmlUnknown.

int Type | ( |  | ) | const
| inline

Query the type (as an enumerated value, above) of this node. The possible types are: DOCUMENT, ELEMENT, COMMENT, UNKNOWN, TEXT, and DECLARATION.

References GetDocument().

const char* Value | ( |  | ) | const
| inline

The meaning of 'value' changes for the specific type of TiXmlNode.

    *   Document: filename of the xml file
    *   Element: name of the element
    *   Comment: the comment text
    *   Unknown: the tag contents
    *   Text: the text string
    *

The subclasses will wrap this function.

The documentation for this class was generated from the following file:

- edelib/TiXml.h